<?php
//ini_set('display_errors',1);
session_start();
date_default_timezone_set('America/Lima');
require_once '../../config/Cado.php';
require_once '../cotizacion/cCotizacion.php';
$oCotizacion = new cCotizacion();
require_once("../cotizacion/cCotizacionpago.php");
$oCotizacionpago = new cCotizacionpago();
require_once("../producto/cProductomarcacodigo.php");
$oProductomarcacodigo = new cProductomarcacodigo();
require_once ("../talonario/cTalonario.php");
$oTalonario= new cTalonario();
require_once ("../producto/cCatalogo.php");
$oCatalogo = new cCatalogo();
require_once("../producto/cProducto.php");
$oProducto = new cProducto();
require_once("../tipocambiotesoreria/cTipocambiotesoreria.php");
$oTipocambiotesoreria = new cTipocambiotesoreria();
require_once ("../documento/cDocumento.php");
$oDocumento = new cDocumento();
require_once("../formatos/formato.php");
function responder($estado=false, $mensaje='', $datos=[])
{
	header('Content-type: application/json');
	echo json_encode([
		'est' => $estado,
		'msj' => $mensaje,
		'dat' => $datos,
	]);
	exit;
}
$fecha = date('Y-m-d'); 
if($_POST['action']=='actualizar_estado'){
	
	$oCotizacion->modificar_campo($_POST['cotid'],'edi','0');
	$data['msj'] = 'Se cancelo la modificacion correctamente.';
	echo json_encode($data);
	
}
if($_POST['action'] == 'editar'){
if(!empty($_POST['cotid']))
{
	$mon_id=$_POST['monid'];
	
	//$_POST['docid'] = '10';
	
$dts=$oDocumento->mostrarUno($_POST['docid']);
	$dt = mysqli_fetch_array($dts);
	$mod_id=$dt['tb_modulo_id'];
	$doc_abr=$dt['tb_documento_abr'];
	$doc_nom=$dt['tb_documento_nom'];
	$doc_def=$dt['tb_documento_def'];
	$imp_id=$dt['tb_impresora_id'];
	mysqli_free_result($dts);
if($doc_abr=='T'){
	$ser = 'T00'.$_SESSION['usuario_ser'];
}else if($doc_abr=='F'){
	$ser = 'F00'.$_SESSION['usuario_ser'];
}else if($doc_abr=='B'){
	$ser = 'B00'.$_SESSION['usuario_ser'];
}else if($doc_abr=='GR'){
	$ser = 'GR00'.$_SESSION['usuario_ser'];
}else if($doc_abr=='NC'){
	$ser = 'NC00'.$_SESSION['usuario_ser'];
}else if($doc_abr=='P'){
	$ser = 'P00'.$_SESSION['usuario_ser'];
}else if($doc_abr=='C'){
	$ser = 'C00'.$_SESSION['usuario_ser'];
}
// echo $_POST['punvenid'].'--'.$ser;
		$dts= $oTalonario->correlativo($_POST['punvenid'],$_POST['docid'],$ser);
		$dt = mysqli_fetch_array($dts);
			$tal_id=$dt['tb_talonario_id'];
			$tal_ser=$dt['tb_talonario_ser'];
			$tal_fin=$dt['tb_talonario_fin'];
			$tal_num=$dt['tb_talonario_num'];
		mysqli_free_result($dts);
		$numero=$tal_num;
		$largo=strlen($tal_fin);
		$numero=str_pad($numero,$largo, "0", STR_PAD_LEFT);
		$numdoc=$tal_ser.'-'.$numero;
		
		
		$fecha = date('Y-m-d');
		$rstes = $oTipocambiotesoreria->consultar($fecha);  
		$dttes = mysqli_fetch_array($rstes);
		$tipcamtes =  formato_money($dttes['tb_tipocambiotesoreria_val']);
		
		$oCotizacion->insertar(
			fecha_mysql($fecha),
			$_POST['docid'],
			$numdoc,
			$_POST['cliid'],
			$_POST['clinom'],
			$_POST['clidir'],
			$_POST['clipla'],
			moneda_mysql($_POST['valven']),
			intval(moneda_mysql($_POST['des'])),
			moneda_mysql($_POST['igv']),			
			moneda_mysql($_POST['tot']),
			intval(moneda_mysql($_POST['dia'])),
			intval(moneda_mysql($_POST['mec'])),
			'1',			
			$_SESSION['usuario_id'],
			$_SESSION['usuario_id'],
			$mon_id,
			$tipcamtes,
			$_POST['punvenid'],
			'0',
			'0',
			$_POST['cot_obs'],
			fecha_mysql($_POST['feceve']),
			moneda_mysql($_POST['modpag_id']),
			moneda_mysql($_POST['cot_ade'])
			
		);
		
		$dts=$oCotizacion->ultimoInsert();
		$dt = mysqli_fetch_array($dts);
		$cotidn=$dt['id'];
		mysqli_free_result($dts);
		
		
		$estado='1';
		if($tal_num==$tal_fin)
		{
			$estado='2';
		}
		$numero=$tal_num+1;
		$oTalonario->actualizar_correlativo($tal_id, $numero, $estado);
		
		
		if(isset($_SESSION['cotizacion_catid']))foreach($_SESSION['cotizacion_catid'] as $indice=>$linea_cantidad)
		{
			$marid = $_SESSION['cotizacion_marid'][$indice];			
			$cat_id = $_SESSION['cotizacion_catid'][$indice];
			$pro_nom = $_SESSION['cotizacion_pronom'][$indice];
			
			$dts=$oCatalogo->mostrarUno($cat_id,$marid);
			$dt = mysqli_fetch_array($dts);
				$pre_id	= $dt['tb_presentacion_id'];
				$cat_cod = $dt['tb_producto_id'];
				$cat_fac = $dt['tb_catalogo_fac'];
				//$pro_nom = $dt['tb_producto_nom'];
			mysqli_free_result($dts);		
			
			$can=$_SESSION['cotizacion_can'][$indice];		
			$valor_uni=$_SESSION['cotizacion_preven'][$indice];
			$des_uni = $_SESSION['cotizacion_des'][$indice];	
			
			//$rscod = $oProductomarcacodigo->mostrarUno($cat_id,'1');
			//$dtcod = mysqli_fetch_array($rscod);
			
			//$cat_cod = $dtcod['tb_producto_id'];
			
			$oCotizacion->insertar_detalle(
				$cat_cod,
				$cat_id,
				$marid,
				$pro_nom,
				moneda_mysql($can),
				moneda_mysql($valor_uni),
				moneda_mysql($des_uni),
				$cotidn
			);
			
		}
		
		
	/* 
	$dtsc=$oCotizacion->mostrarCotizaciondetalle($_POST['cotid']);
	$num_rows= mysqli_num_rows($dtsc);
	
	while($dtc = mysqli_fetch_array($dtsc))
    {
		
		$dts1=$oCatalogo->mostrarUno($dtc['tb_catalogo_id'],$dtc['tb_marca_id']);
		$dt1 = mysqli_fetch_array($dts1);
		
			$can=$dtc['tb_cotizaciondetalle_can']*1;		
			$valor_uni=$dtc['tb_cotizaciondetalle_valuni'];
			$des_uni = $dtc['tb_cotizaciondetalle_des'];
		
			$igv_uni = $valor_uni *0.18;
			$pre_uni= $valor_uni * 1.18;
			
			$val_tot = $valor_uni * $can;		
			$igv_tot = ($valor_uni *0.18) * $can;
			$pre_tot = ($valor_uni * 1.18) * $can;
			
			$total_valorventa +=$val_tot;
			$total_igv	+=$igv_tot;
			$total	+=$pre_tot;
			
			$cod = $dtc['tb_catalogo_cod'];
	
		$oCotizacion->insertar_detalle(
				$cod,
				$dtc['tb_catalogo_id'],
				$dtc['tb_marca_id'],
				$dtc['tb_cotizaciondetalle_nom'],
				$can,
				$valor_uni,
				$des_uni,
				$cotidn
			);
	
	} */
	
	$oCotizacion->modificar_campo($_POST['cotid'],'est','3');
	
	// $oCotizacion->editar(moneda_mysql($_POST['valven']),moneda_mysql($_POST['des']),moneda_mysql($_POST['igv']),moneda_mysql($_POST['tot']),$_POST['cotid']);
	
	$data['cot_act']=1;
	$data['cotid']=$cotidn;
	$data['msj']='Cotizacion actualizado.';
	
}else{
	$data['msj']='Por favor intentelo nuevamente.';
}
echo json_encode($data);
}






if($_POST['action_cotizacion'] == 'insertar'){
if(!empty($_POST['txt_ven_fec']))
	{
		$mon_id=$_POST['txt_mone_id'];
		$_POST['doc_id'] = '32';
		
$dts=$oDocumento->mostrarUno($_POST['doc_id']);
	$dt = mysqli_fetch_array($dts);
	$mod_id=$dt['tb_modulo_id'];
	$doc_abr=$dt['tb_documento_abr'];
	$doc_nom=$dt['tb_documento_nom'];
	$doc_def=$dt['tb_documento_def'];
	$imp_id=$dt['tb_impresora_id'];
	mysqli_free_result($dts);
if($doc_abr=='T'){
	$ser = 'T00'.$_SESSION['usuario_ser'];
}else if($doc_abr=='F'){
	$ser = 'F00'.$_SESSION['usuario_ser'];
}else if($doc_abr=='B'){
	$ser = 'B00'.$_SESSION['usuario_ser'];
}else if($doc_abr=='GR'){
	$ser = 'GR00'.$_SESSION['usuario_ser'];
}else if($doc_abr=='NC'){
	$ser = 'NC00'.$_SESSION['usuario_ser'];
}else if($doc_abr=='C'){
	$ser = 'C00'.$_SESSION['usuario_ser'];
}
		
		$dts= $oTalonario->correlativo(1,$_POST['doc_id'],$ser);
		$dt = mysqli_fetch_array($dts);
			$tal_id=$dt['tb_talonario_id'];
			$tal_ser=$dt['tb_talonario_ser'];
			$tal_fin=$dt['tb_talonario_fin'];
			$tal_num=$dt['tb_talonario_num'];
		mysqli_free_result($dts);
		$numero=$tal_num;
		$largo=strlen($tal_fin);
		$numero=str_pad($numero,$largo, "0", STR_PAD_LEFT);
		$numdoc=$tal_ser.'-'.$numero;
		
		
		$fecha = date('Y-m-d');
		$rstes = $oTipocambiotesoreria->consultar($fecha);  
		$dttes = mysqli_fetch_array($rstes);
		$tipcamtes =  formato_money($dttes['tb_tipocambiotesoreria_val']);
		
		
		$oCotizacion->insertar(
			fecha_mysql($_POST['txt_ven_fec']),
			$_POST['doc_id'],
			$numdoc,
			$_POST['hdd_ven_cli_id'],
			$_POST['txt_ven_cli_nom'],
			$_POST['cmb_ven_cli_dir'],
			$_POST['cmb_ven_cli_vehi'],
			moneda_mysql($_POST['txt_ven_valven']),
			intval(moneda_mysql($_POST['txt_ven_des'])),
			moneda_mysql($_POST['txt_ven_igv']),			
			moneda_mysql($_POST['txt_ven_totsdes']),
			intval($_POST['txt_cot_dia']),
			intval($_POST['hdd_cot_mec_id']),
			'1',			
			$_POST['hdd_usu_id'],
			$_POST['hdd_usu_id'],
			$mon_id,
			$tipcamtes,
			$_POST['txt_punven_id'],
			'0',
			'0',
			$_POST['txt_cot_obs'],
			fecha_mysql($_POST['txt_ven_feceve']),
			moneda_mysql($_POST['cmb_modpag_id']),
			moneda_mysql($_POST['txt_cot_ade'])
		);
		
		$dts=$oCotizacion->ultimoInsert();
		$dt = mysqli_fetch_array($dts);
		$cotid=$dt['id'];
		mysqli_free_result($dts);
		
		
		$estado='1';
		if($tal_num==$tal_fin)
		{
			$estado='2';
		}
		$numero=$tal_num+1;
		$oTalonario->actualizar_correlativo($tal_id, $numero, $estado);
		
		
	
		
		if(isset($_SESSION['cotizacion_catid']))foreach($_SESSION['cotizacion_catid'] as $indice=>$linea_cantidad)
		{
			$marid = $_SESSION['cotizacion_marid'][$indice];			
			$cat_id = $_SESSION['cotizacion_catid'][$indice];
			$pro_nom = $_SESSION['cotizacion_pronom'][$indice];
			
			$dts=$oCatalogo->mostrarUno($cat_id,$marid);
			$dt = mysqli_fetch_array($dts);
				$pre_id	= $dt['tb_presentacion_id'];
				$cat_fac = $dt['tb_catalogo_fac'];
				//$pro_nom = $dt['tb_producto_nom'];
				$pro_id = $dt['tb_producto_id'];
			mysqli_free_result($dts);		
			
			$can=$_SESSION['cotizacion_can'][$indice];		
			$valor_uni=$_SESSION['cotizacion_preven'][$indice];
			$des_uni = $_SESSION['cotizacion_des'][$indice];	
			
			/* $rscod = $oProductomarcacodigo->mostrarUno($cat_id,'1');
			$dtcod = mysqli_fetch_array($rscod);
			
			$cat_cod = $dtcod['tb_productomarcacodigo_cod']; */
			
			$oCotizacion->insertar_detalle(
				$pro_id,
				$cat_id,
				$marid,
				$pro_nom,
				moneda_mysql($can),
				moneda_mysql($valor_uni),
				moneda_mysql(0),
				$cotid
			);
			
		}
		$data['cot_act']=1;
	$data['cotid']=$cotid;
	$data['msj']='Cotizacion Nº '.$numdoc.' registrada';
	}else{
		
	$data['msj']='Por favor intentelo nuevamente registrada';
	}
echo json_encode($data);
} 
if($_POST['action_cotizacion']=="eliminar"){
	if(!empty($_POST['cotid']))
	{
			$oCotizacion->modificar_campo($_POST['cotid'],'xac','0');
			$data['msj'] = 'Se eliminó cotizacion correctamente.';
	}
	else
	{
		 $data['msj'] = 'Intentelo nuevamente.';
	}
	echo json_encode($data);
}
if($_POST['action']=="quitar"){
	if(!empty($_POST['detcotid']))
	{
			$oCotizacion->eliminardetalle($_POST['detcotid']);
			responder(true, 'Item eliminado correctamente.', ['tipo' => 'eliminado']);
		
	}
	else
	{
		responder(true, 'Intentelo nuevamente.', ['tipo' => 'eliminado']);
	}
	echo json_encode($data);
}
if($_POST['action_cotizacion']=="actualizarestado"){
	if(!empty($_POST['cotid']))
	{
			$oCotizacion->modificar_campo($_POST['cotid'],$_POST['campo'],$_POST['valor']);
			$data['msj'] = 'Cotizacion Nº '. $_POST['texto'].' a sido actualizada correctamente.';
	}
	else
	{
		$data['msj'] = 'Intentelo nuevamente.';
	}
	echo json_encode($data);
}
if($_POST['action']=="agregaritem"){
	
	if(!empty($_POST['detcotid']))
	{
		//echo $_POST['cat_id'] .' -mar '.$_POST['mar_id'];
		
		$dts1=$oCatalogo->mostrarUno($_POST['cat_id'],$_POST['mar_id']);
		$dt1 = mysqli_fetch_array($dts1);
		
		$pronom = $dt1['tb_producto_nom'];
		$ran = $dt1['tb_catalogo_ran'];
		
		$rscod = $oProductomarcacodigo->mostrarUno($_POST['cat_id'],'1');
		$dtcod = mysqli_fetch_array($rscod);	
		$cat_cod = $dtcod['tb_productomarcacodigo_cod'];
		
		$rstes = $oTipocambiotesoreria->consultar($fecha);  
		$dttes = mysqli_fetch_array($rstes);
		$tipcamtes =  formato_money($dttes['tb_tipocambiotesoreria_val']);
		$dtsprecio = $oProducto->ver_precio_mayor_producto($_POST['cat_id'],$_POST['mar_id']);
		$numrowpre = mysqli_num_rows($dtsprecio);
		
		$i = 1;
		
		while($dtpre = mysqli_fetch_array($dtsprecio)){
			
			if($dtpre['tb_moneda_id']==1){
				$premay = $dtpre['PREMAY'];
			}else if($dtpre['tb_moneda_id']==2){
				$premay = $dtpre['PREMAY']*$tipcamtes;				
			}
			
			// echo 'premay :' .$premay;
			$_SESSION['pre'.$i] = $premay;
					
		}
		
		if($_SESSION['pre1']>$_SESSION['pre2']){
				$precio = $_SESSION['pre1'];		
		}else if($_SESSION['pre2']>$_SESSION['pre1']){
				$precio = $_SESSION['pre2'];
		}
		
		// echo $precio;
		
		if($numrowpre>0){
			
		$ranmon = ($precio * $ran)/100;
		$premin = $precio + $ranmon ;
		$pre_5 = ($premin * 5)/100;
		$presug = $premin + $pre_5 ;	
			
		}else{
		
		$premin = 0;
		$presug = 0;
		
		}
		
		if($_POST['cat_preven']==""){
			
			if($_POST['mon'] == 1){
			$preven = $premin ;
			$preven1 = $presug;
			$msjmon = ' SOLES';
			}else{
			$preven = $premin / $tipcamtes;
			$preven1 = ($presug / $tipcamtes);
			$msjmon = ' DOLARES';
			} 
		
		}else{
			
			if($_POST['mon'] == 1){
			$preven = $premin  ;
			$preven1 = $_POST['cat_preven'];
			$msjmon = ' SOLES';
			}else{
			$preven = $premin ;
			$preven1 = $_POST['cat_preven'] ;// $tipcamtes;
			$msjmon = ' DOLARES';
			}
			
		}
		
		if($numrowpre>0){
			//echo $preven1.' - '.$preven;
			
			if(moneda_mysql($preven1) < moneda_mysql($preven)){
				$_SESSION['cotizacion_preven'][$_POST['cat_id'].$_POST['mar_id']]= moneda_mysql($preven/1.18);	
				
			$oCotizacion->editar_detalle(
				$cat_cod,
				$_POST['cat_id'],
				$_POST['mar_id'],
				$pronom,
				$_POST['cat_can'],
				$_SESSION['cotizacion_preven'][$_POST['cat_id'].$_POST['mar_id']],
				$des,
				$_POST['detcotid']
			);	
				
				responder(false, 'EL REPUESTO '.$pronom.' NO SE PUEDE VENDER A MENOS DE '.formato_money($preven).$msjmon, ['tipo' => 'preven']);
			
			}else{
				$_SESSION['cotizacion_preven'][$_POST['cat_id'].$_POST['mar_id']]= moneda_mysql($preven1/1.18);				
			}
			
		}else{
			$_SESSION['cotizacion_preven'][$_POST['cat_id'].$_POST['mar_id']]= moneda_mysql($preven1/1.18);
			
		}
		
		if($_POST['cat_des']==""){
			$des = 0;
		}else{
			$des = $_POST['cat_des'];
		}
		
		
		$oCotizacion->editar_detalle(
				$cat_cod,
				$_POST['cat_id'],
				$_POST['mar_id'],
				$pronom,
				$_POST['cat_can'],
				$_SESSION['cotizacion_preven'][$_POST['cat_id'].$_POST['mar_id']],
				$des,
				$_POST['detcotid']
			);	
		
		unset($_SESSION['pre1']);
		unset($_SESSION['pre2']);
		
		responder(true, 'Item agregado', ['tipo' => 'agregado']);
	}
	else
	{
		$data['msj'] = 'Intentelo nuevamente.';
	}
	echo json_encode($data);	
}
if($_POST['action']=="agregar"){
	if(!empty($_POST['cotid']))
	{
		
		$dts1=$oCatalogo->mostrarUno($_POST['cat_id'],$_POST['mar_id']);
		$dt1 = mysqli_fetch_array($dts1);
		
		$pronom = $dt1['tb_producto_nom'];
		$ran = $dt1['tb_catalogo_ran'];
		
		
		$rstes = $oTipocambiotesoreria->consultar($fecha);  
		$dttes = mysqli_fetch_array($rstes);
		$tipcamtes =  formato_money($dttes['tb_tipocambiotesoreria_val']);
		$dtsprecio = $oProducto->ver_precio_mayor_producto($_POST['cat_id'],$_POST['mar_id']);
		$numrowpre = mysqli_num_rows($dtsprecio);
		
		$i = 1;
		
		while($dtpre = mysqli_fetch_array($dtsprecio)){
			
			if($dtpre['tb_moneda_id']==1){
				$premay = $dtpre['PREMAY'];
			}else if($dtpre['tb_moneda_id']==2){
				$premay = $dtpre['PREMAY']*$tipcamtes;				
			}
			
			// echo 'premay :' .$premay;
			$_SESSION['pre'.$i] = $premay;
		
		
		}
		
		
		
		if($_SESSION['pre1']>$_SESSION['pre2']){
				$precio = $_SESSION['pre1'];		
		}else if($_SESSION['pre2']>$_SESSION['pre1']){
				$precio = $_SESSION['pre2'];
		}
		
		
		if($numrowpre>0){
			
		$ranmon = ($precio * $ran)/100;
		$preventot = $precio + $ranmon ;	
		$v_uni = $preventot/1.18;
		
		$preven1 = $v_uni ;
			
		}else{
		
		$preven1 = 0;
		
		}
		
		if($_POST['cat_preven']==""){
				if($_POST['mon'] == 1){
			$preven = $preven1 ;
			$preven1 = $preven1;
			$msjmon = ' SOLES';
		}else{
			$preven = $preven1 / $tipcamtes;
			$preven1 = $preven1 / $tipcamtes;
			$msjmon = ' DOLARES';
			}
		}else{
			if($_POST['mon'] == 1){
			$preven = $_POST['cat_preven'] ;
			$preven1 = $preven1;
			$msjmon = ' SOLES';
		}else{
			$preven = $_POST['cat_preven'];
			$preven1 = $preven1 / $tipcamtes;
			$msjmon = ' DOLARES';
		}
		}
		
		if($numrowpre>0){
			
			if(formato_money($preven)<formato_money($preven1)){
				responder(false, 'EL REPUESTO '.$pronom.' NO SE PUEDE VENDER A MENOS DE '.formato_money($preven1).$msjmon, ['tipo' => 'preven']);
			}else{
				$_SESSION['cotizacion_preven'][$_POST['cat_id'].$_POST['mar_id']]= moneda_mysql($preven);				
			}
			
		}else{
			$_SESSION['cotizacion_preven'][$_POST['cat_id'].$_POST['mar_id']]= moneda_mysql($preven);
			
		}
		
		$dts=$oCatalogo->mostrarUno($_POST['cat_id'],$_POST['mar_id']);
			$dt = mysqli_fetch_array($dts);
				$pre_id	= $dt['tb_presentacion_id'];
				$cat_fac = $dt['tb_catalogo_fac'];
				$pro_nom = $dt['tb_producto_nom'];
				$pro_id = $dt['tb_producto_id'];
			mysqli_free_result($dts);	
		
		/* $rscod = $oProductomarcacodigo->mostrarUno($_POST['cat_id'],'1');
		$dtcod = mysqli_fetch_array($rscod);
			
		$cat_cod = $dtcod['tb_productomarcacodigo_cod']; */
		
		if($_POST['cat_des']==""){
			$des = 0;
		}else{
			$des = $_POST['cat_des'];
		}
		
		$oCotizacion->insertar_detalle(
				$pro_id,
				$_POST['cat_id'],
				$_POST['mar_id'],
				$pro_nom,
				$_POST['cat_can'],
				$preven,
				0,
				$_POST['cotid']
			);	
		
		unset($_SESSION['pre1']);
		unset($_SESSION['pre2']);
		
		responder(true, 'Item agregado', ['tipo' => 'agregado']);
		
		
		
	}
	else
	{
		$data['msj'] = 'Intentelo nuevamente.';
	}
	echo json_encode($data);
}
?>